<?php
/**
 * Created by Axiao
 * Date: 2024/8/26
 * Time: 下午1:26
 */

namespace certification\hmyidentity\logic;

use certification\hmyidentity\HmyidentityPlugin;

class Hmyidentity
{

    public $_config;

    public function __construct(){
        
        if (file_exists(dirname(__DIR__).'/config/config.php')){
            $con = require dirname(__DIR__).'/config/config.php';
        }else{
            $con = [];
        }
        $config = (new HmyidentityPlugin())->getConfig();
        
        $this->_config = array_merge($con,$config);
    }

    public function identify($realname,$idcard,$cert_type) {
        session_start();
        $params = [
                'username' => $this->_config['username'],
                'key' => $this->_config['key'],
                'identify_type' => $this->_config['identify_type'],
                'return_url' => $this->_config['return_url'],
                'biz_code' => $this->_config['biz_code']
            ];
        $params['out_trade_no'] = "ZGYD20240826" . time();
        $params['cert_type'] = $cert_type;
        $params['name'] = $realname;
        $params['card'] = $idcard;
        
        //var_dump($params);exit;
        
        
        // print_r($_SESSION);
        // exit;

        if(!$_SESSION['identify']) {
            
            $result=$this->APIHttpRequestCURL("identify",$params,$this->_config);
            
            if ($result['code'] == 200) {
                $_SESSION['identify'] = $result['data']['out_trade_no'].'|'.$result['data']['url'];
                $jsonMsg['status'] = 200;
                $jsonMsg['msg'] = "请使用支付宝扫描二维码";
                $jsonMsg['url'] = $result['data']['url'];
                $jsonMsg['out_trade_no'] = $result['data']['out_trade_no'];
                return $jsonMsg;
            } else {
                $jsonMsg['status'] = 200;
                $jsonMsg['msg'] = $result['msg'];
                return $jsonMsg;
            }
        } else {

            $data = explode("|",$_SESSION['identify']);

            $jsonMsg['status'] = 200;
            $jsonMsg['msg'] = "请使用支付宝扫描二维码";
            $jsonMsg['url'] = $data[1];
            $jsonMsg['out_trade_no'] = $data[0];
            return $jsonMsg;

        }
    }

    public function query($out_trade_no) {
        session_start();
        $_SESSION['count'] += 1;
        $params = [
                'username' => $this->_config['username'],
                'key' => $this->_config['key'],
            ];
        $params['out_trade_no'] = $out_trade_no;
        $result=$this->APIHttpRequestCURL("query",$params,$this->_config);
        
        
        
        $status = 4; # 已提交资料
        if($result['code']==200){
            unset($_SESSION['count']);
            unset($_SESSION['identify']);
            $status = 1; # 通过
            $msg = '审核通过';
        }
        if($_SESSION['count'] >= 20 && $result['code'] == 0){
            unset($_SESSION['count']);
            unset($_SESSION['identify']);
            $msg = $result['msg'];
            $status = 2;
        }
    
        
        return ['status'=>$status,'msg'=>$msg];
    }

    private function APIHttpRequestCURL($action,$param,$config,$method='POST'){

        if($action == 'identify') {
            $api = 'https://yun.jxhcyun.com/api/index/identify';
        }  else if($action == 'query') {
            $api = 'https://yun.jxhcyun.com/api/index/identify_query';
            
        }



        // $postfields=http_build_query($param);

            $ch = curl_init();
            curl_setopt_array($ch, array(
                CURLOPT_URL => $api,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_POSTFIELDS => $param,
                CURLOPT_CUSTOMREQUEST => strtoupper($method),
            ));

        $output = curl_exec($ch);
 
        curl_close($ch);
        // $output = trim($output, "\xEF\xBB\xBF");
        return json_decode($output,true);
    }

}